/**
 * 
 */

function FrameBuffer(width, height) {
	
	this.texture = gl.createTexture();
	
	this.width = width;
	this.height = height;

	gl.bindTexture(gl.TEXTURE_2D, this.texture);
 
    // Set up texture so we can render any size image and so we are
    // working with pixels.
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
    
    gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, width, height, 0, gl.RGBA, gl.UNSIGNED_BYTE, null);

    this.fbo = gl.createFramebuffer();
    
    gl.bindFramebuffer(gl.FRAMEBUFFER, this.fbo);
    gl.framebufferTexture2D(
            gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, this.texture, 0);
    
    gl.bindFramebuffer(gl.FRAMEBUFFER, null);
    
    console.log("Created FBO " + this.texture + " " + this.fbo);

    this.clear = true;
    
    this.beginRender = function() {
    	
    	gl.bindFramebuffer(gl.FRAMEBUFFER, this.fbo);
    	
    	gl.disable(gl.DEPTH_TEST);           // Enable depth testing
    	gl.depthFunc(gl.LEQUAL);            // Near things obscure far things


    	gl.viewport(0, 0, this.width, this.height); // gl.viewportWidth, gl.viewportHeight);
    	
        if (this.clear) {
    	    gl.clearColor(0.0, 0.0, 0.0, 1.0);  // Set clear color to black, fully opaque
    	    gl.clearDepth(1.0);                 // Clear everything
    	    gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
        }

    }
    
    this.endRender = function() {
    	
    	gl.bindFramebuffer(gl.FRAMEBUFFER, null);
    	
    }
    
}
